Bug 862368

Summary: Review Request: xkbset - Tool to configure XKB extensions
Product: [Fedora] Fedora Reporter: Till Maas <opensource>
Component: Package ReviewAssignee: Matthias Runge <mrunge>
Status: CLOSED CURRENTRELEASE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: kas, mrunge, notting, opensource, package-review
Target Milestone: ---Flags: mrunge: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-11-09 04:17:58 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Till Maas 2012-10-02 14:03:20 EDT
Spec URL: http://till.fedorapeople.org/review/xkbset.spec
SRPM URL: http://till.fedorapeople.org/review/xkbset-0.5-1.Tillf17.src.rpm
Description: xkbset is a program rather like xset in that it allows you to set various
features of the X window interface.  It allows one to configure most of the
options connected with the XKB extensions.  They are described in Section 10 of
XKBlib.ps.

This includes customizing the following:
  MouseKeys:  using the numeric pad keys to move the mouse;
  StickyKeys: where modifiers like control and shift will lock until the
              next key press (good for one finger typing);
  SlowKeys:   The keys will not work unless they are pressed for a certain
              amount of time;
  BounceKeys: If a key is pressed more than once rapidly, only one key
              press will be registered.
Fedora Account System Username: till
Comment 1 Matthias Runge 2012-10-03 02:38:55 EDT
I'll take this for review
Comment 2 Matthias Runge 2012-10-03 03:00:50 EDT
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[!]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[-]: Large documentation files are in a -doc subpackage, if required.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "BSD (2 clause)". 1 files have unknown license. Detailed output of
     licensecheck in /home/mrunge/review/862368-xkbset/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[-]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[!]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (xkbset-0.5.tar.gz)
[x]: SourceX is a working URL.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: xkbset-debuginfo-0.5-1.fc19.x86_64.rpm
          xkbset-0.5-1.fc19.src.rpm
          xkbset-0.5-1.fc19.x86_64.rpm
xkbset.src: W: spelling-error %description -l en_US xset -> set, x set, sextet
xkbset.x86_64: W: spelling-error %description -l en_US xset -> set, x set, sextet
xkbset.x86_64: W: spurious-executable-perm /usr/share/man/man1/xkbset.1.gz
xkbset.x86_64: W: manual-page-warning /usr/share/man/man1/xkbset.1.gz 123: name expected (got a special character): treated as missing
xkbset.x86_64: W: manual-page-warning /usr/share/man/man1/xkbset.1.gz 128: name expected (got a special character): treated as missing
xkbset.x86_64: W: manual-page-warning /usr/share/man/man1/xkbset.1.gz 134: name expected (got a special character): treated as missing
xkbset.x86_64: W: manual-page-warning /usr/share/man/man1/xkbset.1.gz 142: name expected (got a special character): treated as missing
xkbset.x86_64: W: no-manual-page-for-binary xkbset-gui
3 packages and 0 specfiles checked; 0 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint xkbset-debuginfo xkbset
xkbset.x86_64: W: spelling-error %description -l en_US xset -> set, x set, sextet
xkbset.x86_64: W: spurious-executable-perm /usr/share/man/man1/xkbset.1.gz
xkbset.x86_64: W: manual-page-warning /usr/share/man/man1/xkbset.1.gz 123: name expected (got a special character): treated as missing
xkbset.x86_64: W: manual-page-warning /usr/share/man/man1/xkbset.1.gz 128: name expected (got a special character): treated as missing
xkbset.x86_64: W: manual-page-warning /usr/share/man/man1/xkbset.1.gz 134: name expected (got a special character): treated as missing
xkbset.x86_64: W: manual-page-warning /usr/share/man/man1/xkbset.1.gz 142: name expected (got a special character): treated as missing
xkbset.x86_64: W: no-manual-page-for-binary xkbset-gui
2 packages and 0 specfiles checked; 0 errors, 7 warnings.
# echo 'rpmlint-done:'



Requires
--------
xkbset-debuginfo-0.5-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    

xkbset-0.5-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/perl  
    libX11.so.6()(64bit)  
    libc.so.6()(64bit)  
    perl(Tk)  
    rtld(GNU_HASH)  



Provides
--------
xkbset-debuginfo-0.5-1.fc19.x86_64.rpm:
    
    xkbset-debuginfo = 0.5-1.fc19
    xkbset-debuginfo(x86-64) = 0.5-1.fc19

xkbset-0.5-1.fc19.x86_64.rpm:
    
    xkbset = 0.5-1.fc19
    xkbset(x86-64) = 0.5-1.fc19



MD5-sum check
-------------
http://www.math.missouri.edu/~stephen/software/xkbset/xkbset-0.5.tar.gz :
  CHECKSUM(SHA256) this package     : 01c2579495b39e00d870f50225c441888dc88021e9ee3b693a842dd72554d172
  CHECKSUM(SHA256) upstream package : 01c2579495b39e00d870f50225c441888dc88021e9ee3b693a842dd72554d172



Besides the minor (you intentionally left that rm -rf %{buildroot} in install section, to have something for the reviewer), this didn't switch off slow keys: xkbset -sl, hit shif a long time and eventionally that annoying function kicks in.

Also, I'm not sure, what's going on with the man page (that special char warning), but you definitely should fix the following:
-rwxr-xr-x    1 root    root                     2447 Oct  3 08:36 /usr/share/man/man1/xkbset.1.gz

(executable bit is not required for the man page)
Comment 3 Till Maas 2012-10-03 04:20:51 EDT
Spec URL: http://till.fedorapeople.org/review/xkbset.spec
SRPM URL: http://till.fedorapeople.org/review/xkbset-0.5-2.Tillf17.src.rpm

- Use a patch to fix Makefile
- Do not remove buildroot in %%install
- Add .desktop file

I asked upstream about the man page. It seems to be that the lines rpmlint warns about are supposed to be comments but are a quotation sign (") missing.

One thing about the should items:
> [!]: SourceX / PatchY prefixed with %{name}.
>     Note: Source0 (xkbset-0.5.tar.gz)

As far as I know SourceX/PatchY can either be prefixed by %{name} literally or by the value %{name} expands to, therefore there is nothing wrong.

About the functional problem:
With the slowkeys on/off setting, you can do the same that pressing the shift key for eight seconds does. To disable the possibility to use the shift key, AccessX needs to be disabled with 'xkbset -accessx'.
Comment 4 Matthias Runge 2012-10-03 05:06:32 EDT
Great! Everything is fixed, and I see no other issues.

(In reply to comment #3)
> One thing about the should items:
> > [!]: SourceX / PatchY prefixed with %{name}.
> >     Note: Source0 (xkbset-0.5.tar.gz)
> 
Yes, I see that as a false positive.


Package APPROVED
Comment 5 Till Maas 2012-10-04 03:39:01 EDT
New Package SCM Request
=======================
Package Name: xkbset
Short Description: Configure XKB extensions
Owners: till
Branches: f17 f18
InitialCC:
Comment 6 Jon Ciesla 2012-10-04 07:22:49 EDT
Git done (by process-git-requests).
Comment 7 Fedora Update System 2012-10-04 08:10:26 EDT
xkbset-0.5-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/xkbset-0.5-2.fc17
Comment 8 Fedora Update System 2012-10-04 08:10:41 EDT
xkbset-0.5-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/xkbset-0.5-2.fc18
Comment 9 Fedora Update System 2012-10-04 13:49:31 EDT
xkbset-0.5-2.fc18 has been pushed to the Fedora 18 testing repository.